unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FMTBcd, DBXpress, IBDatabase, ADODB, DBTables, DB, SqlExpr,
  IBCustomDataSet, IBQuery, IBTable, StdCtrls;

type
  TForm1 = class(TForm)
    SQLDataSet1: TSQLDataSet;
    SQLTable1: TSQLTable;
    SQLQuery1: TSQLQuery;

    ADOTable1: TADOTable;
    ADODataSet1: TADODataSet;
    ADOQuery1: TADOQuery;

    IBTable1: TIBTable;
    IBQuery1: TIBQuery;
    IBDataSet1: TIBDataSet;

    Table1: TTable;
    Query1: TQuery;

    SQLConnection1: TSQLConnection;
    Database1: TDatabase;
    ADOConnection1: TADOConnection;
    IBDatabase1: TIBDatabase;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    IBTransaction1: TIBTransaction;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure OpenDatasets;
    procedure CloseDatasets;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  IBDatabase1.Connected    := True;
  ADOConnection1.Connected := True;
  Database1.Connected      := True;
  SQLConnection1.Connected := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDatasets;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseDatasets;
  IBDatabase1.Connected    := false;
  ADOConnection1.Connected := false;
  Database1.Connected      := false;
  SQLConnection1.Connected := false;
end;

procedure TForm1.CloseDatasets;
begin

  // Disconnect from dbExpress datasets
  SQLDataSet1.Close;  // or .Active := false;
  SQLTable1.Close;    // or .Active := false;
  SQLQuery1.Close;    // or .Active := false;

  // Disconnect from ADO datasets
  ADOTable1.Close;    // or .Active := false;
  ADODataSet1.Close;  // or .Active := false;
  ADOQuery1.Close;    // or .Active := false;

  // Disconnect from Interbase Express datasets
  IBTable1.Close;    // or .Active := false;
  IBQuery1.Close;    // or .Active := false;
  IBDataSet1.Close;  // or .Active := false;

  // Disconnect from BDE datasets
  Table1.Close;    // or .Active := false;
  Query1.Close;    // or .Active := false;

  Label1.Caption := 'Datasets are closed.'
end;

procedure TForm1.OpenDatasets;
begin

  // Connect to dbExpress datasets
  SQLDataSet1.Open;  // or .Active := true;
  SQLTable1.Open;    // or .Active := true;
  SQLQuery1.Open;    // or .Active := true;

  // Connect to ADO datasets
  ADOTable1.Open;    // or .Active := true;
  ADODataSet1.Open;  // or .Active := true;
  ADOQuery1.Open;    // or .Active := true;

  // Connect to Interbase Express datasets
  IBTable1.Open;    // or .Active := true;
  IBQuery1.Open;    // or .Active := true;
  IBDataSet1.Open;  // or .Active := true;

  // Connect to BDE datasets
  Table1.Open;    // or .Active := true;
  Query1.Open;    // or .Active := true;

  Label1.Caption := 'Datasets are open.';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  CloseDatasets;
end;

end.
