unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FMTBcd, DBXpress, IBDatabase, ADODB, DBTables, DB, SqlExpr,
  IBCustomDataSet, IBQuery, IBTable, StdCtrls, Grids, DBGrids, ExtCtrls;

type
  TForm1 = class(TForm)
    SQLTable1: TSQLTable;
    ADOTable1: TADOTable;
    IBTable1: TIBTable;
    Table1: TTable;

    SQLConnection1: TSQLConnection;
    Database1: TDatabase;
    ADOConnection1: TADOConnection;
    IBDatabase1: TIBDatabase;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    IBTransaction1: TIBTransaction;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    RadioGroup1: TRadioGroup;
    btnFirst: TButton;
    btnLast: TButton;
    btnNext: TButton;
    btnPrior: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPriorClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
    procedure OpenDatasets;
    procedure CloseDatasets;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  IBDatabase1.Connected    := True;
  ADOConnection1.Connected := True;
  Database1.Connected      := True;
  SQLConnection1.Connected := True;

  Datasource1.DataSet := IBTable1;
  OpenDatasets;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDatasets;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseDatasets;
  IBDatabase1.Connected    := false;
  ADOConnection1.Connected := false;
  Database1.Connected      := false;
  SQLConnection1.Connected := false;
end;

procedure TForm1.CloseDatasets;
begin

  // Disconnect from dbExpress dataset
  SQLTable1.Close;    // or .Active := false;

  // Disconnect from ADO dataset
  ADOTable1.Close;    // or .Active := false;

  // Disconnect from Interbase Express dataset
  IBTable1.Close;    // or .Active := false;

  // Disconnect from BDE datasets
  Table1.Close;    // or .Active := false;

  Label1.Caption := 'Datasets are closed.'
end;

procedure TForm1.OpenDatasets;
begin

  // Connect to dbExpress dataset
  SQLTable1.Open;    // or .Active := true;

  // Connect to ADO dataset
  ADOTable1.Open;    // or .Active := true;

  // Connect to Interbase Express dataset
  IBTable1.Open;    // or .Active := true;

  // Connect to BDE dataset
  Table1.Open;    // or .Active := true;

  Label1.Caption := 'Datasets are open.';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  CloseDatasets;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0: Datasource1.DataSet := IBTable1;
    1: Datasource1.DataSet := Table1;
    2: Datasource1.DataSet := ADOTable1;
  end; // case
end;

procedure TForm1.btnFirstClick(Sender: TObject);
begin
  DataSource1.DataSet.First;
end;

procedure TForm1.btnLastClick(Sender: TObject);
begin
  DataSource1.DataSet.Last;
end;

procedure TForm1.btnNextClick(Sender: TObject);
begin
  DataSource1.DataSet.Next;
end;

procedure TForm1.btnPriorClick(Sender: TObject);
begin
  DataSource1.DataSet.Prior;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  btnLast.Enabled := not DataSource1.DataSet.Eof;
  btnNext.Enabled := not DataSource1.DataSet.Eof;
  btnFirst.Enabled := not DataSource1.DataSet.Bof;
  btnPrior.Enabled := not DataSource1.DataSet.Bof;
end;

end.
