{==================================================================
  QddgRgpEdt Unit - TddgRadioGroupEditor CLX Component Editor

  Copyright  2001 by Ray Konopka
==================================================================}

unit QddgRgpEdt;

interface

uses
  DesignIntf, DesignEditors, QExtCtrls, QDdgDsnEdt;

type
  TddgRadioGroupEditor = class( TddgDefaultEditor )
  protected
    function RadioGroup: TRadioGroup; virtual;
  public
    function GetVerbCount: Integer; override;
    function GetVerb( Index: Integer ) : string; override;
    procedure ExecuteVerb( Index: Integer ); override;
  end;


implementation

uses
  QControls;

{==================================}
{== TddgRadioGroupEditor Methods ==}
{==================================}

function TddgRadioGroupEditor.RadioGroup: TRadioGroup;
begin
  // Helper function to provide quick access to component being
  // edited.  Also makes sure Component is a TRadioGroup
  Result := Component as TRadioGroup;
end;

function TddgRadioGroupEditor.GetVerbCount: Integer;
begin
  // Return the number of new menu items to display
  Result := RadioGroup.Items.Count + 1;
end;


function TddgRadioGroupEditor.GetVerb( Index: Integer ): string;
begin
  // Menu item caption for context menu
  if Index = 0 then
    Result := 'Edit Items...'
  else
    Result := RadioGroup.Items[ Index - 1 ];
end;


procedure TddgRadioGroupEditor.ExecuteVerb( Index: Integer );
begin
  if Index = 0 then
    EditPropertyByName( 'Items' )      // Defined in QDdgDsnEdt.pas
  else
  begin
    if RadioGroup.ItemIndex <> Index - 1 then
      RadioGroup.ItemIndex := Index - 1
    else
      RadioGroup.ItemIndex := -1;              // Uncheck all items
    Designer.Modified;
  end;
end;

end.
