unit Bank_impl;

interface

uses
  SysUtils, CORBA, Bank_i, Bank_c;

type
  TAccount = class;

  TAccount = class(TInterfacedObject, Bank_i.Account)
  protected
    _balance : Single;
  public
    constructor Create;
    procedure deposit (const amount : Single);
    procedure withdraw (const amount : Single);
    function  balance : Single;
  end;


implementation

constructor TAccount.Create;
begin
  inherited;
  _balance := random(10000);
end;

procedure TAccount.deposit(const amount : Single);
begin
  if amount > 0 then
    _balance := _balance + amount;
end;

procedure TAccount.withdraw(const amount : Single);
begin
  if amount < _balance then
    _balance := _balance - amount
  else
    raise EWithdrawError.Create(_balance);
end;

function  TAccount.balance : Single;
begin
  result := _balance;
end;


initialization
  randomize;

end.