unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Rio, SoapHTTPClient;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    btnLogon: TButton;
    btnLogoff: TButton;
    Label1: TLabel;
    Label2: TLabel;
    edtUser: TEdit;
    edtPasswd: TEdit;
    edtSessionHandle: TEdit;
    GroupBox3: TGroupBox;
    edtSessionData: TEdit;
    btnSetData: TButton;
    btnGetData: TButton;
    lblSessionData: TLabel;
    HTTPRIO1: THTTPRIO;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnLogonClick(Sender: TObject);
    procedure btnLogoffClick(Sender: TObject);
    procedure btnSetDataClick(Sender: TObject);
    procedure btnGetDataClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses AuthenticatorIntf;

{$R *.dfm}
var
  Srv : IAuthenticator;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Srv := HTTPRIO1 as IAuthenticator;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Srv.Logout(edtSessionHandle.Text);
  Srv := nil;
end;

procedure TForm1.btnLogonClick(Sender: TObject);
var
  SH : String;
begin
  if not Srv.Login(edtUser.Text,edtPasswd.Text,SH) then
    raise Exception.Create ('Invalid Login');
  edtSessionHandle.Text := SH;
end;

procedure TForm1.btnLogoffClick(Sender: TObject);
begin
  if not Srv.Logout(edtSessionHandle.Text) then
    raise Exception.Create('Cannot logout!');
  edtSessionHandle.Clear;
end;

procedure TForm1.btnSetDataClick(Sender: TObject);
begin
  Srv.AddSessionData(edtSessionHandle.Text,edtSessionData.Text)
end;

procedure TForm1.btnGetDataClick(Sender: TObject);
begin
  lblSessionData.Caption := Srv.GetSessionData(edtSessionHandle.Text);
end;

end.
