unit ClientMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, MConnect, StdCtrls, Grids, DBGrids, ComCtrls;

type
  TForm2 = class(TForm)
    dcDDGSimple: TDCOMConnection;
    cdsCustomer: TClientDataSet;
    dsCustomer: TDataSource;
    btnApplyUpdates: TButton;
    btnCancelUpdates: TButton;
    btnRevertRecord: TButton;
    btnUndoLastChange: TButton;
    btnSetSavePoint: TButton;
    btnGotoSavePoint: TButton;
    PageControl1: TPageControl;
    tsData: TTabSheet;
    tsDelta: TTabSheet;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    cdsDelta: TClientDataSet;
    dsDelta: TDataSource;
    procedure btnApplyUpdatesClick(Sender: TObject);
    procedure btnCancelUpdatesClick(Sender: TObject);
    procedure btnRevertRecordClick(Sender: TObject);
    procedure btnUndoLastChangeClick(Sender: TObject);
    procedure btnSetSavePointClick(Sender: TObject);
    procedure btnGotoSavePointClick(Sender: TObject);
    procedure cdsCustomerReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure PageControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FSavePoint: integer;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  RecError;
  
{$R *.DFM}

procedure TForm2.btnApplyUpdatesClick(Sender: TObject);
begin
  cdsCustomer.ApplyUpdates(0);
end;

procedure TForm2.btnCancelUpdatesClick(Sender: TObject);
begin
  cdsCustomer.CancelUpdates;
end;

procedure TForm2.btnRevertRecordClick(Sender: TObject);
begin
  cdsCustomer.RevertRecord;
end;

procedure TForm2.btnUndoLastChangeClick(Sender: TObject);
begin
  cdsCustomer.UndoLastChange(true);
end;

procedure TForm2.btnSetSavePointClick(Sender: TObject);
begin
  FSavePoint := cdsCustomer.SavePoint;
end;

procedure TForm2.btnGotoSavePointClick(Sender: TObject);
begin
  cdsCustomer.SavePoint := FSavePoint;
end;

procedure TForm2.cdsCustomerReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(Dataset, UpdateKind, E);
end;

procedure TForm2.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = tsDelta then
    cdsDelta.Data := cdsCustomer.Delta else
    cdsDelta.Close;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  cdsCustomer.Open;
end;

end.
