unit InetXRDM;

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, InetXServer_TLB, StdVcl, Db, Provider, DBTables;

type
  TDDGInetX = class(TRemoteDataModule, IDDGInetX)
    CustomerQuery: TQuery;
    OrderQuery: TQuery;
    EmployeeQuery: TQuery;
    Database1: TDatabase;
    Session1: TSession;
    CustomerProvider: TDataSetProvider;
    EmployeeProvider: TDataSetProvider;
    CustomerSource: TDataSource;
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

class procedure TDDGInetX.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

initialization
  TComponentFactory.Create(ComServer, TDDGInetX,
    Class_DDGInetX, ciMultiInstance, tmApartment);
end.
