
unit wmPreferenceInput;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, WebModu, HTTPProd,
  CompProd, PagItems, SiteProd, WebForm, WebComp, MidItems, WebAdapt;

type
  TPreferenceInput = class(TWebPageModule)
    AdapterPageProducer: TAdapterPageProducer;
    PrefAdapter: TAdapter;
    LikesChocolateField: TAdapterBooleanField;
    FavoriteMovieField: TAdapterField;
    PasswordHintField: TAdapterField;
    AdapterForm1: TAdapterForm;
    AdapterFieldGroup1: TAdapterFieldGroup;
    SubmitAction: TAdapterAction;
    AdapterCommandGroup1: TAdapterCommandGroup;
    AdapterActionButton: TAdapterActionButton;
    AdapterErrorList1: TAdapterErrorList;
    FldAdapterBooleanField1: TAdapterDisplayField;
    FldAdapterField1: TAdapterDisplayField;
    FldAdapterField2: TAdapterDisplayField;
    procedure SubmitActionExecute(Sender: TObject; Params: TStrings);
    procedure LikesChocolateFieldGetValue(Sender: TObject;
      var Value: Boolean);
    procedure FavoriteMovieFieldGetValue(Sender: TObject;
      var Value: Variant);
    procedure PasswordHintFieldGetValue(Sender: TObject;
      var Value: Variant);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function PreferenceInput: TPreferenceInput;

implementation

{$R *.dfm}  {*.html}

uses WebReq, WebCntxt, WebFact, Variants, wmHome;


function PreferenceInput: TPreferenceInput;
begin
  Result := TPreferenceInput(WebContext.FindModuleClass(TPreferenceInput));
end;

procedure TPreferenceInput.SubmitActionExecute(Sender: TObject;
  Params: TStrings);
var
  Value: IActionFieldValue;
begin

  Value := FavoriteMovieField.ActionValue;
  if Value.ValueCount > 0 then
  begin
    Session.Values[sFavoriteMovie] := Value.Values[0];
  end;

  Value := PasswordHintField.ActionValue;
  if Value.ValueCount > 0 then
  begin
    Session.Values[sPasswordHint] := Value.Values[0];
  end;

  Value := LikesChocolateField.ActionValue;
  if Value <> nil then
  begin
    if Value.ValueCount > 0 then
    begin
      Session.Values[sLikesChocolate] := Value.Values[0];
    end;
  end else
  begin
    Session.Values[sLikesChocolate] := 'false';
  end;;
end;

procedure TPreferenceInput.LikesChocolateFieldGetValue(Sender: TObject;
  var Value: Boolean);
var
  S: string;
begin
  S := Session.Values[sLikesChocolate];
  Value := S = 'true';
end;

procedure TPreferenceInput.FavoriteMovieFieldGetValue(Sender: TObject;
  var Value: Variant);
begin
  Value := Session.Values[sFavoriteMovie];
end;

procedure TPreferenceInput.PasswordHintFieldGetValue(Sender: TObject;
  var Value: Variant);
begin
  Value := Session.Values[sPasswordHint];
end;

initialization
  if WebRequestHandler <> nil then
    WebRequestHandler.AddWebModuleFactory(TWebPageModuleFactory.Create(TPreferenceInput, TWebPageInfo.Create([wpPublished, wpLoginRequired], '.html'), crOnDemand, caCache));

end.
