
unit wmUpload;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, WebModu, HTTPProd,
  CompProd, PagItems, SiteProd, MidItems, WebForm, WebComp, WebAdapt;

type
  TUpload = class(TWebPageModule)
    AdapterPageProducer: TAdapterPageProducer;
    Adapter1: TAdapter;
    AdapterFileField1: TAdapterFileField;
    AdapterForm1: TAdapterForm;
    AdapterErrorList1: TAdapterErrorList;
    AdapterFieldGroup1: TAdapterFieldGroup;
    FldAdapterFileField1: TAdapterDisplayField;
    UploadAction: TAdapterAction;
    AdapterCommandGroup1: TAdapterCommandGroup;
    CmdUploadAction: TAdapterActionButton;
    procedure AdapterFileField1UploadFiles(Sender: TObject;
      Files: TUpdateFileList);
    procedure UploadActionExecute(Sender: TObject; Params: TStrings);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function Upload: TUpload;

implementation

{$R *.dfm}  {*.html}

uses WebReq, WebCntxt, WebFact, Variants;

function Upload: TUpload;
begin
  Result := TUpload(WebContext.FindModuleClass(TUpload));
end;

procedure TUpload.AdapterFileField1UploadFiles(Sender: TObject;
  Files: TUpdateFileList);
var
  i: integer;
  CurrentDir: string;
  Filename: string;
  FS: TFileStream;
begin
  // Upload file here
    if Files.Count <= 0 then
    begin
      Adapter1.Errors.AddError('You have not selected any files to be uploaded');
      Exit;
    end;
    for i := 0 to Files.Count - 1 do
    begin
    // Make sure that the file is a .jpg or .jpeg
    if (CompareText(ExtractFileExt(Files.Files[I].FileName), '.jpg') <> 0)
        and (CompareText(ExtractFileExt(Files.Files[I].FileName), '.jpeg') <> 0) then
    begin
      Adapter1.Errors.AddError('You must select a JPG or JPEG file to upload');
    end else
    begin
      CurrentDir := ExtractFilePath(GetModuleName(HInstance)) + 'JPEGFiles';
      ForceDirectories(CurrentDir);
      FileName := CurrentDir + '\' + ExtractFileName(Files.Files[I].FileName);
      FS := TFileStream.Create(Filename, fmCreate or fmShareDenyWrite);
      try
        FS.CopyFrom(Files.Files[I].Stream, 0); // 0 = copy all from start
      finally
        FS.Free;
      end;
    end;
  end;
end;

procedure TUpload.UploadActionExecute(Sender: TObject; Params: TStrings);
begin
  Adapter1.UpdateRecords;
end;

initialization
  if WebRequestHandler <> nil then
    WebRequestHandler.AddWebModuleFactory(TWebPageModuleFactory.Create(TUpload, TWebPageInfo.Create([wpPublished, wpLoginRequired], '.html'), crOnDemand, caCache));

end.
